import * as mc from "@minecraft/server";

function ejecutarConRetraso() {
    let delayTicks = Math.floor(Math.random() * (90 - 20 + 1)) + 20;

    mc.system.runTimeout(() => {
        let players = mc.world.getPlayers();
        let entities = mc.world.getDimension("overworld").getEntities({ type: "ld:long_legged_steve" });

        entities.forEach(entity => {
            players.forEach(player => {
                let direction = player.getViewDirection();
                let entityPos = entity.location;
                let playerPos = player.location;

                let dx = entityPos.x - playerPos.x;
                let dz = entityPos.z - playerPos.z;
                let distance = Math.sqrt(dx * dx + dz * dz);

                let mirando = (dx * direction.x + dz * direction.z) > 0;

                if (distance < 7 && mirando) {
                    if (Math.random() < 0.4) { 
                        let newX, newY, newZ, tries = 0;

                        do {
                            let offsetX = Math.random() * 80 - 60;
                            let offsetZ = Math.random() * 80 - 60;
                            let newPos = { x: playerPos.x + offsetX, y: playerPos.y, z: playerPos.z + offsetZ };

                            let block = mc.world.getDimension("overworld").getBlock(newPos);
                            if (block.isAir || block.isWater) {
                                newX = newPos.x;
                                newY = newPos.y;
                                newZ = newPos.z;
                                break;
                            }
                            tries++;
                        } while (tries < 10);

                        let numParticles = Math.floor(Math.random() * 30) + 20;
                        for (let i = 0; i < numParticles; i++) {
                            let offsetX = Math.random() * 1.5 - 0.75;
                            let offsetY = Math.random() * 2.5;
                            let offsetZ = Math.random() * 1.5 - 0.75;
                            mc.world.getDimension("overworld").spawnParticle("minecraft:basic_smoke_particle", { 
                                x: entityPos.x + offsetX, 
                                y: entityPos.y + offsetY, 
                                z: entityPos.z + offsetZ 
                            });
                        }

                        mc.world.getDimension("overworld").playSound("ambient.cave", entityPos);

                        entity.teleport({ x: newX, y: newY, z: newZ }, mc.world.getDimension("overworld"));
                    }
                }
            });
        });

        ejecutarConRetraso();
    }, delayTicks);
}

ejecutarConRetraso();