import * as mc from "@minecraft/server";

const MIN_TICKS = 12000; // 12000 ticks - 10 minutos
const MAX_TICKS = 576000; // 576000 ticks - 2 días de Minecraft
let tiempoManifestacion = getRandomTime();
let ticksTranscurridos = 0;

function getRandomTime() {
    return Math.floor(Math.random() * (MAX_TICKS - MIN_TICKS) + MIN_TICKS);
}

mc.system.runInterval(() => {
    ticksTranscurridos += 20;

    if (ticksTranscurridos < tiempoManifestacion) return;

    let dimension = mc.world.getDimension("overworld");
    let existentes = dimension.getEntities({ type: "ld:long_legged_steve" });

    if (existentes.length > 0) return;

    let players = mc.world.getPlayers();
    if (players.length === 0) return;

    let player = players[Math.floor(Math.random() * players.length)];
    let offsetX = Math.random() * 60 - 40;
    let offsetZ = Math.random() * 60 - 40;
    let spawnPos = { x: player.location.x + offsetX, y: player.location.y, z: player.location.z + offsetZ };

    let longLegged = dimension.spawnEntity("ld:long_legged_steve", spawnPos);

    dimension.runCommand(`particle minecraft:basic_flame_particle ${spawnPos.x} ${spawnPos.y} ${spawnPos.z}`);
    dimension.runCommand(`playsound ambient.cave @a[r=40] ${spawnPos.x} ${spawnPos.y} ${spawnPos.z}`);

    mc.world.sendMessage("§4⚠ Algo oscuro se ha manifestado cerca... ⚠");

    tiempoManifestacion = getRandomTime();
    ticksTranscurridos = 0;
}, 20);